//class of colors 
color clr[] = {#FDE725, #35B779, #515151, #440D54};

public class Liner{
  
  int person_id; // order for ItemLocation and barcode (created to differentiate books that belong to different branches: x-axis)
  //int gen; // gender 
  //int birth; // birth year
  //int trial; // trial year
  //int repr; // repression year
  int age; // age at trial/repr
  String outcome; // outcome of sentence (execution, labor camp, specposel, labor army)  
  //int orig; // random noise for locating points/lines at origin   
  float mapage; // mapped age
  int death;
  
  public Integer getAge() {
        return age;
    }
  
  Liner(int person_id, int age, String outcome, float mapage, int death){
    //this.bibo = bibo;
    this.person_id = person_id;
    //this.gen = gen;
    //this.birth = birth;
    //this.trial = trial;
    //this.repr = repr; 
    this.age = age; 
    this.outcome = outcome;
    //this.orig = orig;  
    this.mapage = mapage;
    this.death = death;
    
    
  }

  // display death for points
  void displayD() {
    // display recorded deaths among all groups of sentences
    colorMode(HSB, 360, 100, 100, 1);
    
    pushMatrix();
    
    translate(width/2, 0);    
    
    // calculate the end point for each line via trig functions
    float mapped_theta = map(person_id, 0, 70621, 0, 180.0);
    //float theta = random(90,180); 
    float px = cos(radians(mapped_theta)) * mapage;//age;
    float py = sin(radians(mapped_theta)) * mapage;//age; 
    
    if((outcome.equals("vmn")) || (death==1)) {
      noStroke();
      fill(0,0,0); // yellow
      //fill(clr[0],0.25);
      ellipse(px, py, 5, 5);
    }
    
    popMatrix(); 
  }
  
  // display death for lines
  void displayDL() {
    // display recorded deaths among all groups of sentences
    colorMode(HSB, 360, 100, 100, 1);
    
    pushMatrix();
    
    translate(width/2, 0);    
    
    // calculate the end point for each line via trig functions
    float mapped_theta = map(person_id, 0, 70621, 0, 180.0);
    //float theta = random(90,180); 
    float px = cos(radians(mapped_theta)) * mapage;//age;
    float py = sin(radians(mapped_theta)) * mapage;//age; 
    
    if((outcome.equals("vmn")) || (death==1)) {
      stroke(0,0,0); 
      strokeWeight(1);
      line(0, 0, px, py); 
    }
    
    popMatrix(); 
  }
  
  
  // display points with key controls and loops
  void displayPts() {
    colorMode(HSB, 360, 100, 100, 1);
    
    pushMatrix();
    
    translate(width/2, 0);
    
    // calculate the end point for each line via trig functions
    float mapped_theta = map(person_id, 0, 70621, 0, 180.0);
    //float theta = random(90,180); 
    float px = cos(radians(mapped_theta)) * mapage;//age;
    float py = sin(radians(mapped_theta)) * mapage;//age; 
    
    //println(px);
      
    //stroke(180,100,100,.25);
    //point(px,py);
    
    if (outcome.equals("trudarm") == true){
        noStroke();
        fill(60,100,100,.25); // yellow
        //fill(clr[0],0.25);
        ellipse(px, py, 5, 5);
    }
    else if (outcome.equals("vmn") == true){
      noStroke();
      fill(0,100,100,.25); //red
      ellipse(px, py, 5, 5);
    }
    else if (outcome.equals("itl") == true){
      noStroke();
      fill(120,100,100,.25);
      //fill(clr[2],0.25);
      ellipse(px, py, 5, 5);
    }
    else if (outcome.equals("specpos") == true){
      noStroke();
      fill(180,100,100,.25);
      //fill(clr[3],0.25);
      ellipse(px, py, 5, 5);
    }
       
    popMatrix();
  }


  // display points with key controls and loops
  void displayLines() {
    colorMode(HSB, 360, 100, 100, 1);
    
    pushMatrix();
    
    translate(width/2, 0);
    
    // calculate the end point for each line via trig functions
    //float mapped_theta = random(0, 180.0);
    float mapped_theta = map(person_id, 0, 70621, 0, 180.0);
    
    //float theta = random(90,180); 
    float px = cos(radians(mapped_theta)) * mapage;//age;
    float py = sin(radians(mapped_theta)) * mapage;//age; 
    //println(px);
      
    //stroke(180,100,100,.25);
    //point(px,py);
    
    if (outcome.equals("trudarm") == true){
      stroke(60,100,100,.25); // yellow
      strokeWeight(1);
      line(0, 0, px, py);  
    }
    else if (outcome.equals("vmn") == true){
      strokeWeight(1);
      stroke(0,100,100,.25); //red
      line(0, 0, px, py);
      // highlight with white if died
    }
    else if (outcome.equals("itl") == true){
      strokeWeight(1);
      stroke(120,100,100,.25);
      line(0, 0, px, py);
    }
    else if (outcome.equals("specpos") == true){
      strokeWeight(1);
      stroke(180,100,100,.25);
      line(0, 0, px, py);
    }
       
    popMatrix();
  }



  //void displayLine() {
    
  //  colorMode(HSB, 360, 100, 100, 1);
    
  //  pushMatrix();
    
  //  translate(width/2, 0);
       
  //  if (outcome.equals("trudarm") == true) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    stroke(240,100,100,.25);   
  //    // stroke(0,100,30,.25); //this is red color
  //    strokeWeight(1);
  //    line(0, 0, px, py);
       
  //  }
    
  //  else if (outcome.equals("vmn") == true) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    stroke(50,100,100,.25);
  //    // stroke(0,100,50,.25);// this is red
  //    strokeWeight(1);
       
  //    line(0, 0, px, py);
       
       
  //  }
    
  //  else if (outcome.equals("itl") == true) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    stroke(115,100,100,.25);
  //    // stroke(0,100,75,.25);// this is red
  //    strokeWeight(1);
       
  //    line(0, 0, px, py);
       
       
  //  }
    
  //  else if (outcome.equals("specpos") == true) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    stroke(180,100,100,.25);
  //    // stroke(0,100,100,.25); //this is red
  //    strokeWeight(1);
       
  //    line(0, 0, px, py);
       
       
  //  }
  //  popMatrix();
  //  //noLoop();
  //}
  
  //void displayPts() {
  //  colorMode(HSB, 360, 100, 100, 1);
    
  //  pushMatrix();
    
  //  translate(width/2, 0);
    
  //  if ((outcome.equals("trudarm") == true)) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    //stroke(240,100,100,.25);
  //    //point(px,py);
  //    noStroke();
  //    fill(240,100,100, 0.25);
  //    ellipse(px, py, 2, 2);
       
  //  }
    
  //  else if ((outcome.equals("vmn") == true)) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    //stroke(50,100,100,.25);
  //    //point(px,py);
  //    noStroke();
  //    fill(50,100,100,.25);
  //    ellipse(px, py, 2, 2);
       
       
  //  }
    
  //  else if ((outcome.equals("itl") == true)) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    //stroke(115,100,100,.25);
  //    //point(px,py);
  //    noStroke();
  //    fill(115,100,100,.25);
  //    ellipse(px, py, 2, 2);
       
       
  //  }
    
  //  else if ((outcome.equals("specpos") == true)) {
  //    // calculate the end point for each line via trig functions
  //    float mapped_theta = random(0, 180.0);
  //    //float theta = random(90,180); 
  //    float px = cos(radians(mapped_theta)) * age;
  //    float py = sin(radians(mapped_theta)) * age; 
  //    //println(px);
      
  //    //stroke(180,100,100,.25);
  //    //point(px,py);
  //    noStroke();
  //    fill(180,100,100,.25);
  //    ellipse(px, py, 2, 2);
       
       
  //  }
  //  popMatrix();
  //  //noLoop();
    
  //}
}  
