void loadData() {
  // Load CSV file into a Table object
  // "header" option indicates the file has a header row
  table = loadTable("wolga_clean.csv", "header");

  // The size of the array is determined by the total number of rows in the CSV
  liners = new Liner[table.getRowCount()]; 

  //iterate over all the rows in a table
  for (int i = 0; i < table.getRowCount(); i++) {
    TableRow row = table.getRow(i);
    // You can access the fields via their column name (or index)
    int person_id = row.getInt("PersonID");
    //int gen = row.getInt("gender");
    //int birth = row.getInt("birth");
    //int trial = row.getInt("TrialYear");
    //int repr = row.getInt("RepressionYear");
    int age = row.getInt("trial_age");
    String outcome = row.getString("outcome");
    //int orig = row.getInt("orig");
    int death = row.getInt("Death");
    
    // map age values to the diagonal of the display   
    //int mapped_age = floor(map(age, 1, 85, 0, sqrt(width/2*width/2 + height/2*height/2)));
    float mapage = map(age, 1, 85, 0, 0.75*sqrt((width/2)*(width/2) + (height/2)*(height/2)));
    
    // Make a Liner object out of the data read
    liners[i] = new Liner(person_id, age, outcome, mapage, death);
  }
}
